package me.yuxiaoyao.config.loader;

import org.junit.jupiter.api.Test;

import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;




class ConfigLoaderTest {

    @Test
    public void resolveProperties() {
        Map<String, Object> map = new LinkedHashMap<>();
        map.put("port", 8080);
        map.put("host", "yuxiaoyao.me");

        Map<String, Object> redis = new LinkedHashMap<>();
        redis.put("host", "127.0.0.1");
        redis.put("redis-port", 6379);
        redis.put("password", "----***____");
        map.put("redis", redis);

        Map<String, Object> app = new LinkedHashMap<>();
        app.put("server", "--");
        app.put("sp", "${redis.host}");
        map.put("app", app);

        Map<String, Object> testInfo = new LinkedHashMap<>();
        testInfo.put("no", "test-server");
        testInfo.put("protocol-no", "${app.sp}");
        testInfo.put("protocol-server", "${app.server}");
        testInfo.put("test-default", "${app.default:2222}");
        testInfo.put("test-port", "${port}");
        testInfo.put("notExit", "${portaaa}");

        map.put("testInfo", testInfo);
        map.put("first", "${redis.passworda:@@@@}");

        System.out.println(map);


        Map<Object, String> preHandler = new HashMap<>();
        // find
        ConfigLoader.findPreResolveProperties(map, preHandler, null);
        System.out.println("find: " + preHandler);
        // replace value
        final Map<Object, Object> objectObjectMap = ConfigLoader.resolveProperties(map, preHandler);
        System.out.println(objectObjectMap);

        // replace to map

        ConfigLoader.replaceProperties(map, objectObjectMap);
        System.out.println("last:" + map);

    }

}